Index: drivers.c
===================================================================
--- drivers.c	(revision 1211)
+++ drivers.c	(working copy)
@@ -726,7 +726,7 @@
 ParseXML( char * buffer, ModulePtr * module, TagPtr * personalities )
 {
 	long       length, pos;
-	TagPtr     moduleDict;
+	TagPtr     moduleDict, required;
 	ModulePtr  tmpModule;
   
     pos = 0;
@@ -746,14 +746,14 @@
   
     if (length == -1) return -1;
 
-#if 0   /** remove this check. **/   
-    if (strcmp(XMLCastString(XMLGetProperty(moduleDict, kPropOSBundleRequired)), "Safe Boot") == 0)
+    required = XMLGetProperty(moduleDict, kPropOSBundleRequired);
+    if ( (required == 0) ||
+         (required->type != kTagTypeString) ||
+         !strcmp(required->string, "Safe Boot"))
     {
-        // Don't load Safe Boot kexts. NOTE: -x should be check too.
         XMLFreeTag(moduleDict);
         return -2;
     }
-#endif 
 
     tmpModule = malloc(sizeof(Module));
     if (tmpModule == 0)
